function [ L,A ] = LRDD(Sigma,k,N)
% The iterative projection algorithm for DD-PCA
% Input: Sigma is the matrix. k is the rank of the low rank part. N is the
% iteration time;  
% Output: low rank part L and diagonal dominant part A 
S=Sigma;
for i=1:N
    [V,D]=eigs(S,k);
    L = V*D*V'; 
    A=ProjSDD(Sigma-L);
    S=Sigma-(A+A')/2;
end
A = (A+A')/2;
end




