%% load pop data 
clear

load('pop.mat')

start_index = 3;
Klist = Klist(start_index:end);

Frob_DD = Frob_DD(:,start_index:end);
Frob_poet = Frob_poet(:,start_index:end);
Twonorm_DD = Twonorm_DD(:,start_index:end);
Twonorm_poet = Twonorm_poet(:,start_index:end);

Frob_InvDD = Frob_InvDD(:,start_index:end);
Frob_Invpoet = Frob_Invpoet(:,start_index:end);
Twonorm_InvDD = Twonorm_InvDD(:,start_index:end);
Twonorm_Invpoet = Twonorm_Invpoet(:,start_index:end);
%% plot
figure 

linewidth = 2;

subplot(2,4,1)
hold on 
plot(Klist,mean(Frob_poet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Frob_DD,1),'-r','LineWidth',linewidth)
xlabel('K')
%ylim([56 58])
ylim([0 60])
ylabel('Mean Error')
title({'Population Covariance Matrix' ; '(Frobenius Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off

subplot(2,4,2)
hold on 
plot(Klist,mean(Twonorm_poet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Twonorm_DD,1),'-r','LineWidth',linewidth)
xlabel('K')
%ylim([40 42])
ylim([0 45])
title({'Population Covariance Matrix'; '(Spectral Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off


subplot(2,4,3)
hold on 
plot(Klist,mean(Frob_Invpoet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Frob_InvDD,1),'-r','LineWidth',linewidth)
xlabel('K')
%ylim([4 6])
ylim([0 6])
title({'Population Precision Matrix'; '(Frobenius Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off


subplot(2,4,4)
hold on 
plot(Klist,mean(Twonorm_Invpoet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Twonorm_InvDD,1),'-r','LineWidth',linewidth)
xlabel('K')
ylim([0 2])
title({'Population Precision Matrix'; '(Spectral Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off

%% load noise data

clear 

load('noise.mat')

start_index = 3;
Klist = Klist(start_index:end);

Frob_DD = Frob_DD(:,start_index:end);
Frob_poet = Frob_poet(:,start_index:end);
Twonorm_DD = Twonorm_DD(:,start_index:end);
Twonorm_poet = Twonorm_poet(:,start_index:end);

Frob_InvDD = Frob_InvDD(:,start_index:end);
Frob_Invpoet = Frob_Invpoet(:,start_index:end);
Twonorm_InvDD = Twonorm_InvDD(:,start_index:end);
Twonorm_Invpoet = Twonorm_Invpoet(:,start_index:end);

%% plot
linewidth = 2;

subplot(2,4,5)
hold on 
plot(Klist,mean(Frob_poet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Frob_DD,1),'-r','LineWidth',linewidth)
xlabel('K')
%ylim([4.5 6.5])
ylim([0 7])
ylabel('Mean Error')
title({'Noise Covariance Matrix';'(Frobenius Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off

subplot(2,4,6)
hold on 
plot(Klist,mean(Twonorm_poet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Twonorm_DD,1),'-r','LineWidth',linewidth)
xlabel('K')
ylim([0 2])
title({'Noise Covariance Matrix'; '(Spectral Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off


subplot(2,4,7)
hold on 
plot(Klist,mean(Frob_Invpoet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Frob_InvDD,1),'-r','LineWidth',linewidth)
xlabel('K')
%ylim([4 6])
ylim([0 6])
title({'Noise Precision Matrix'; '(Frobenius Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off


subplot(2,4,8)
hold on 
plot(Klist,mean(Twonorm_Invpoet,1),'--ob','LineWidth',linewidth)
plot(Klist,mean(Twonorm_InvDD,1),'-r','LineWidth',linewidth)
xlabel('K')
ylim([0 2])
title({'Noise Precision Matrix'; '(Spectral Norm)'})
legend('POET','DD-PCA','Location','southeast')
hold off

%%  print
fig = gcf;
fig.PaperUnits = 'inches';
fig.PaperPosition = [0 0 12 10];
%fig.PaperPositionMode = 'auto';
fig.PaperSize = [12,10];
print('Experiment_v3','-dpdf','-r250')