function [ A ] = ProjSDD( C )
% Project matrix C to the diagonally dominant cone
p=size(C,1);
A=zeros(p,p);
C_d = diag(C);
C_od = abs(C-diag(C_d));
C_ods = sum(C_od,2);
ind1 = C_d>=C_ods;
ind2 = C_d<C_ods & C_d>=0;
ind3 = C_d>=-C_ods & C_d<0 & (abs(C_d) > max(C_od,[],2));
ind4 = C_d>=-C_ods & C_d<0 & ~(abs(C_d) > max(C_od,[],2));
ind5 = C_d<-C_ods;
A(ind1,:) = C(ind1,:);
A(ind3 | ind5,:) = 0;
pos = find(ind2 | ind4);
for l=1:length(pos);
    j=pos(l);
    Cjc = C(j,:);
    Cjc(j)=[];
    [newCjc,idx] = sort(abs(Cjc));
    d = cumsum(newCjc(end:-1:1))-C_d(j);
    d = d(end:-1:1);
    d_bar = d./(p:-1:2);
    m_star = find(newCjc>0 & newCjc>=d_bar,1);
    a=zeros(1,p-1);
    ao=zeros(1,p-1);
    a(1:(m_star-1))=0;
    temp=Cjc(idx)+d_bar(m_star)*(-1).^(Cjc(idx)>0);
    a(m_star:end)=temp(m_star:end);
    ao(idx)=a;
    A(j,:) = [ao(1:(j-1)),C_d(j)+d_bar(m_star),ao(j:end)];
end

end

