function [PsG] = ProjSDDplus( A,N,eps )
% Project matrix A to the symmetric diagonally dominant cone. N is the
% maximum iteration number; eps is the tolerance. 
p = size(A,1);
if nargin<3
    eps = p*1e-3;
end
if nargin<2
    N = 10;
end
G = A;
I = zeros(p);
for i=1:N
    PsG = (G+G')/2;
    newG = ProjSDD(PsG-I);
    I = newG - (PsG-I);
    if norm(G-newG,'fro')<=eps
        break
    end
    G = newG;
end


end

