clear
clc;
rng('default');
%% setting
t1=tic;
p = 500; 
r = 0.05*p; 
trial = 10;
averank = 0;
appro_error = 0;
L_error = 0;
A_error = 0;
%% main loop
for i=1:trial
    X = 1/sqrt(r)*randn(p,r);
    M = X*X';
    a = 1; % control the size of diagonal entries
    A = 1/p*randn(p,p);
    A = A + A';
    A = A-diag(diag(A));
    A = diag(a*sum(abs(A)))+A;
    Sigma = M + A;
    normSigma = norm(Sigma,'fro');
    normM = norm(M,'fro');
    normA = norm(A,'fro');
    % Convex approach (ADMM)
    rho = 1;
    N = 20;
    [M2,A2] = ConvexLRDD(Sigma,rho,N);
    averank = averank + rank(M2);
    appro_error = appro_error + norm(M2+A2-Sigma,'fro')/norm(Sigma);
    L_error = L_error + norm(M2-M,'fro')/normM;
    A_error = A_error + norm(A2-A,'fro')/normA;
    display(i,'Number of trails')
end
averank = averank/trial;
appro_error = appro_error/trial;
L_error = L_error/trial;
A_error = A_error/trial;
toc(t1)
