clear; clc;
rng('default');
%% experiment setting
t1=tic;
plist = [500,1000,2000]; 
rlist = [25,50,100]; 
N = 20;
len=length(plist);
s=zeros(len,N);
l=zeros(len,N);
for i=1:len
    [s(i,:),l(i,:)]=experiment1(plist(i),rlist(i),N);
end
%% plot checkDD
Colorlist=['k','b','r'];
linelist={'-',':','--'};
figure
hold on 
for i=1:len
   plot(s(i,:),'Color',Colorlist(i),'LineStyle',linelist{i},'LineWidth',3)
end
xlabel('Iteration times','FontSize',20)
ylabel('Measure of diagonal dominance','FontSize',20)
legend({['p=' num2str(plist(1))],['p=' num2str(plist(2))],['p=' num2str(plist(3))]},'FontSize',25,'Location','southeast')
set(gca,'FontSize',20)
hold off
fig = gcf;
fig.PaperUnits = 'inches';
fig.PaperPosition = [0 0 9 6];
fig.PaperSize = [9.25,6.25];
print('checkDD','-dpdf','-r250')
%% plot relative error
figure
hold on 
for i=1:len
   plot(l(i,:),'Color',Colorlist(i),'LineStyle',linelist{i},'LineWidth',3)
end
xlabel('Iteration times','FontSize',20)
ylabel('Relative approximation error','FontSize',20)
legend({['p=' num2str(plist(1))],['p=' num2str(plist(2))],['p=' num2str(plist(3))]},'FontSize',25)
set(gca,'FontSize',20)
hold off
fig = gcf;
fig.PaperUnits = 'inches';
fig.PaperPosition = [0 0 9 6];
fig.PaperSize = [9.25,6.25];
print('error','-dpdf','-r250')
toc(t1)