clear; 
clc;
rng('default');
t1 = tic;
%% We first vary noise level
plist = [500,1000,2000]; 
rlist = [25,50,100]; 
N = 15;
lenp = length(plist);
sigmalist = 0.5:0.5:5;
lensigma = length(sigmalist);
Appro_error = zeros(lenp,lensigma);
% loop
for i=1:lenp
    [Appro_error(i,:),~]=experiment2_varyingsigma(plist(i),rlist(i),N,sigmalist);
end
%% plot relative error
Colorlist=['k','b','r'];
linelist={'-',':','--'};
figure
hold on 
for i=1:lenp
   plot(sigmalist,Appro_error(i,:),'Color',Colorlist(i),'LineStyle',linelist{i},'LineWidth',3)
end
xlabel('\sigma','FontSize',30)
ylabel('Relative approximation error','FontSize',20)
legend({['p=' num2str(plist(1))],['p=' num2str(plist(2))],['p=' num2str(plist(3))]},'FontSize',25,'Location','northwest')
set(gca,'FontSize',20)
hold off

fig = gcf;
fig.PaperUnits = 'inches';
fig.PaperPosition = [0 0 9 6];
fig.PaperSize = [9.25,6.25];
print('approx_sigma','-dpdf','-r250')
toc(t1)
%% Now we vary rank
clear; clc;
plist = [500,1000,2000]; 
rlist = 0.01:0.01:0.1;
sigma = 1;
N = 15;
lenp = length(plist);
lenr = length(rlist);
Appro_error = zeros(lenp,lenr);
% loop
for i=1:lenp
    [Appro_error(i,:),~]=experiment2_varyingrank(plist(i),rlist,N,sigma);
end
%% plot relative error
Colorlist=['k','b','r'];
linelist={'-',':','--'};
figure
hold on 
for i=1:lenp
   plot(rlist,Appro_error(i,:),'Color',Colorlist(i),'LineStyle',linelist{i},'LineWidth',3)
end
xlabel('K/p','FontSize',30)
ylabel('Relative approximation error','FontSize',20)
legend({['p=' num2str(plist(1))],['p=' num2str(plist(2))],['p=' num2str(plist(3))]},'FontSize',25,'Location','northwest')
set(gca,'FontSize',20)
hold off

fig = gcf;
fig.PaperUnits = 'inches';
fig.PaperPosition = [0 0 9 6];
fig.PaperSize = [9.25,6.25];
print('approx_rank','-dpdf','-r250')
%%
toc(t1)