% This function can be used to produce figure 9 in DDPCA paper by setting p = 500 or 2000.

clear; 
clc;
rng('default');
%% setting
p = 500; 
r = p*0.05; % rank
X = 1/sqrt(p)*randn(p,r);  
M = X*X';
a = 1; % control the size of diagonal entries
A = 1/p*randn(p,p);
A = A+A';
A = A-diag(diag(A));
A = diag(a*sum(abs(A)))+A;
Sig = M + A;
k=r;
%% PCA
[V,D]=eig(Sig);
d=diag(D);
[~,I]=sort(abs(d),'descend');
index=I(1:k);
T=V(:,index)*diag(d(index))*V(:,index)';  
rem=Sig-T;
sd = diag(1./sqrt(diag(rem)));
rem = sd * rem * sd;
idx = find(~eye(size(rem)));
%% DD-PCA
[ ~,rem2 ] = LRDD(Sig,k,20);
sd2 = diag(1./sqrt(diag(rem2)));
rem2 = sd2 * rem2 * sd2;
idx2 = find(~eye(size(rem2)));
%% plot 
hold on
%ylim([0 5e4])
ylim([0 7000])
histogram(rem(idx),'FaceColor','g','EdgeColor','none')
histogram(rem2(idx2),'FaceColor','k','EdgeColor','none')
legend({'PCA','DD-PCA'},'FontSize',15)
title(['p=',num2str(p),' , ','K=',num2str(k)],'FontSize',20)
set(gca,'FontSize',20)
hold off
fig = gcf;
fig.PaperUnits = 'inches';
fig.PaperPosition = [0 0 9 6];
fig.PaperSize = [9.25,6.25];
print('hist1','-dpdf','-r250')